SystemOrganization addCategory: #'Rizel-Tools'!

Object subclass: #RizelAbstractModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
buildBenchmarks
	^ self class allSelectors
		select: [:t1 | t1 beginsWith: 'bench']! !

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
configurationClass
	^ self subclassResponsability! !

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
executeBenchmark: t1 
	^ 10 timesRepeat: t1! !

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
loadVersion: t1 
	t1 load! !

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
open
	| t1 |
	t1 := Rizel new.
	t1 model: self.
	t1 benchmarks: self buildBenchmarks.
	t1 openWithSpec.
	^ t1! !

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
profile: t1 in: t2 
	self loadVersion: t2.
	^ self profilerClass profile: t1 usingConfiguration: self configurationClass! !

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
profilerClass
	^ RzProfilerSpy! !

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
versionLabel
	^ [:t1 | t1 versionNumber asString]! !

!RizelAbstractModel methodsFor: 'rizel' stamp: ''!
versions
	^ (self configurationClass project versions
		select: [:t1 | t1 importedVersions size > 0]) reversed asOrderedCollection! !

ComposableModel subclass: #BenchmarkBrowser
	instanceVariableNames: 'classes methods code selectedClass selectedSelector browser ok cancel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!BenchmarkBrowser class methodsFor: 'specs' stamp: ''!
defaultSpec
	^ {#ComposableSpec. #add:. {{#model. #classes. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0 @ 0 corner: 0.5 @ 0.5. 0 @ 0 corner: 0 @ 0}}. #add:. {{#model. #methods. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0.5 @ 0 corner: 1 @ 0.5. 0 @ 0 corner: 0 @ 0}}. #add:. {{#model. #code. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0 @ 0.5 corner: 1 @ 1. 0 @ 0 corner: 0 @ 25}}. #add:. {{#model. #ok. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 1 @ 1 corner: 1 @ 1. -100 @ -25 corner: -50 @ 0}}. #add:. {{#model. #cancel. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 1 @ 1 corner: 1 @ 1. -50 @ -25 corner: 0 @ 0}}}! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: ''!
open
	| t1 |
	t1 := BenchmarkBrowser new.
	t1 classes: Smalltalk allClasses.
	t1 openWithSpec.
	^ t1! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: ''!
openOn: t1 
	| t2 |
	t2 := BenchmarkBrowser new.
	t2 classes: Smalltalk allClasses.
	t2 browser: t1.
	t2 openWithSpec.
	^ t2! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: ''!
title
	^ 'Benchmark Browser'! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
browser
	^ browser! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
browser: t1 
	browser := t1! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
cancel
	cancel
		ifNil: [cancel := self instantiate: ButtonModel.
			cancel
				whenActionPerformedDo: [self close].
			cancel label: 'cancel'].
	^ cancel! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
classes
	^ classes! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
classes: t1 
	classes items: t1! !

!BenchmarkBrowser methodsFor: 'specs' stamp: ''!
close
	self delete! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
code
	^ code! !

!BenchmarkBrowser methodsFor: 'specs' stamp: ''!
initializeWidgets
	classes := self instantiate: IconListModel.
	classes
		whenSelectedItemChanged: [:t1 | t1
				ifNotNilDo: [:t2 | 
					selectedClass := t2.
					self
						methods: (t2 methodDict values
								sort: [:t3 :t4 | t3 selector < t4 selector])]].
	methods := self instantiate: IconListModel.
	methods
		whenSelectedItemChanged: [:t1 | t1
				ifNotNilDo: [:t2 | 
					selectedSelector := t2.
					code text: t2 sourceCode]].
	methods
		displayBlock: [:t1 | t1 selector].
	code := self instantiate: TextModel! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
methods
	^ methods! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
methods: t1 
	methods items: t1! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
ok
	ok
		ifNil: [ok := self instantiate: ButtonModel.
			ok label: 'Ok'.
			ok
				whenActionPerformedDo: [(selectedClass notNil
							and: [selectedSelector notNil])
						ifTrue: [browser addBench: selectedSelector methodReference
									-> [(selectedClass new setTestSelector: selectedSelector asSymbol) run]].
					self close]].
	^ ok! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
selectedBenchClass
	^ selectedClass! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: ''!
selectedBenchSelector
	^ selectedSelector! !

ComposableModel subclass: #Rizel
	instanceVariableNames: 'versions benchmarks model options roassal benchs morphView profilePicker builder result versionLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!Rizel class methodsFor: 'spec' stamp: ''!
defaultSpec
	^ {#ComposableSpec. #add:. {{#model. #versions. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0 @ 0.5 corner: 0.3 @ 1. 2 @ 10 corner: 2 @ 2}}. #add:. {{#model. #benchmarks. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0 @ 0 corner: 0.3 @ 0.5. 2 @ 30 corner: 2 @ 2}}. #add:. {{#model. #options. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0 @ 0 corner: 0.3 @ 0. 2 @ 25 corner: 2 @ 2}}. #add:. {{#model. #roassal. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0.3 @ 0 corner: 1 @ 1. 0 @ 0 corner: 0 @ 0}}}! !

!Rizel class methodsFor: 'spec' stamp: ''!
openWith: t1 
	| t2 |
	t2 := Rizel new.
	t2 configurationModel: t1.
	t2 openWithSpec.
	^ t2! !

!Rizel class methodsFor: 'spec' stamp: ''!
title
	^ 'Rizel'! !

!Rizel methodsFor: 'accessing' stamp: ''!
addBench: t1 
	benchs add: t1.
	self benchmarks: benchs! !

!Rizel methodsFor: 'action' stamp: ''!
addBenchmark
	BenchmarkBrowser openOn: self! !

!Rizel methodsFor: 'accessing' stamp: ''!
benchmarks
	^ benchmarks! !

!Rizel methodsFor: 'accessing' stamp: ''!
benchmarks: t1 
	self benchmarks items: t1! !

!Rizel methodsFor: 'action' stamp: ''!
compare
	| t1 t2 t3 |
	t1 := model profile: profilePicker A second in: profilePicker A first.
	t2 := model profile: profilePicker B second in: profilePicker B first.
	t3 := profilePicker A first > profilePicker B first
				ifTrue: [RzProfile merge: t2 with: t1]
				ifFalse: [RzProfile merge: t1 with: t2].
	(RzVisualizerMerge on: t3) visualize! !

!Rizel methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	benchs := OrderedCollection new! !

!Rizel methodsFor: 'initialization' stamp: ''!
initializeWidgets
	versions := self instantiate: ListComposableModel.
	versions beMultipleSelection.
	benchmarks := self instantiate: ListComposableModel.
	benchmarks
		displayBlock: [:t1 | t1 asString].
	benchmarks beMultipleSelection.
	options := self instantiate: RizelOptions.
	options browser: self.
	roassal := self instantiate: RoassalModel! !

!Rizel methodsFor: 'accessing' stamp: ''!
model: t1 
	model := t1.
	self versions: model versions.
	versions displayBlock: model versionLabel! !

!Rizel methodsFor: 'accessing' stamp: ''!
options
	^ options! !

!Rizel methodsFor: 'action' stamp: ''!
profile
	builder := RzBuilder new.
	builder
		define: #input
		named: #version
		with: self selectedVersions.
	builder
		define: #input
		named: #benchmark
		with: self selectedBenchmarks.
	result := builder
				execute: [:t1 :t2 | 
					model loadVersion: t1.
					[model perform: t2] timeToRun].
	profilePicker := RzVisualizer2D new.
	profilePicker xValues: self selectedVersions;
		 yValues: self selectedBenchmarks;
		 xLabel: model versionLabel;
		
		yLabel: [:t1 | t1 asString];
		
		value: [:t1 :t2 | result at: RzVector <== t1 + t2];
		 padding: 150;
		 visualizeOn: self view! !

!Rizel methodsFor: 'accessing' stamp: ''!
roassal
	^ roassal! !

!Rizel methodsFor: 'accessing' stamp: ''!
selectedBenchmarks
	^ self benchmarks selectedItems asSortedCollection! !

!Rizel methodsFor: 'accessing' stamp: ''!
selectedVersions
	^ self versions selectedItems asSortedCollection! !

!Rizel methodsFor: 'rizel' stamp: ''!
versionLabel: t1 
	versionLabel := t1! !

!Rizel methodsFor: 'accessing' stamp: ''!
versions
	^ versions! !

!Rizel methodsFor: 'accessing' stamp: ''!
versions: t1 
	self versions items: t1! !

!Rizel methodsFor: 'accessing' stamp: ''!
view
	^ roassal view! !

ComposableModel subclass: #RizelOptions
	instanceVariableNames: 'add profile compare browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelOptions class methodsFor: 'specs' stamp: ''!
defaultSpec
	<spec>
	^ {#Panel. #changeTableLayout. #listDirection:. #rightToLeft. #addMorph:. {#model. #profile. #defaultSpec}. #addMorph:. {#model. #compare. #defaultSpec}. #hResizing:. #spaceFill. #vResizing:. #shrinkWrap}! !

!RizelOptions class methodsFor: 'specs' stamp: ''!
title
	^ 'Rizel Options'! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
add
	add
		ifNil: [add := self instantiate: ButtonModel.
			add
				whenActionPerformedDo: [browser addBenchmark].
			add label: '+ bench'].
	^ add! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
browser
	^ browser! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
browser: t1 
	browser := t1! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
compare
	compare
		ifNil: [compare := self instantiate: ButtonModel.
			compare
				whenActionPerformedDo: [browser compare].
			compare label: 'Compare'].
	^ compare! !

!RizelOptions methodsFor: 'initialize-release' stamp: ''!
initializeWidgets
	^ self! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
profile
	profile
		ifNil: [profile := self instantiate: ButtonModel.
			profile
				whenActionPerformedDo: [browser profile].
			profile label: 'Profile'].
	^ profile! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
window
	^ window! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
window: t1 
	window := t1! !

ComposableModel subclass: #RoassalModel
	instanceVariableNames: 'builder container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RoassalModel class methodsFor: 'as yet unclassified' stamp: ''!
defaultSpec
	^ {#ComposableSpec. #addMorphWrapper:. {#MorphWrapper. #morph:. {#model. #container}. #fullFrame:. {#LayoutFrame. #fractions:offsets:. 0 @ 0 corner: 1 @ 1. 2 @ 2 corner: 2 @ 2}}}! !

!RoassalModel class methodsFor: 'as yet unclassified' stamp: ''!
title
	^ 'RoassalSpec'! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: ''!
container
	^ container! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: ''!
initializeWidgets
	| t1 |
	builder := ROMondrianViewBuilder new.
	t1 := ROViewStack new addView: builder container;
				 title: builder container title.
	container := (ROMorph on: t1)
				extent: 300 @ 300! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: ''!
update
	self update: #container! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: ''!
view
	^ builder! !
